;Opcodes added to TASM v1.2
;basically all the undocumented ops, and a few variations on the standard z80 syntax
;ie. RST 1..7 instead or RST 8 etc, EX HL,DE as well as EX DE,HL and stuff like that
;
; Undocumented ops have class bit 2 set, so are xnabled by -x5
; Opcodes which are just standard variatons are included in the default set
;
; The only "made up" opcode is OUT0 (C), which I felt was preferable to OUT (C),0 in some
; situations. Everywhere else I've tried to stick to standard Z80 instructions.
;
; XH,XL,YH,YL are used instead of the alternatives IXH,IXL,IYH,IYL because I'm far too
; lazy to use three letter names. ;-) 


	ADC A,XH
	ADC A,XL
	ADC A,YH
	ADC A,YL

	ADD A,XH
	ADD A,XL
	ADD A,YH
	ADD A,YL

	AND XH
	AND XL
	AND YH
	AND YL

	CP XH
	CP XL
	CP YH
	CP YL

	DEC XH
	DEC XL
	DEC YH
	DEC YL

	EX HL,(SP)
	EX IX,(SP)
	EX IY,(SP)
	EX AF',AF
	EX HL,DE

	IN F,(C)

	INC XH
	INC XL
	INC YH
	INC YL
	
;Okay so here they are, the probably-very-pointless-but-funky-nonetheless instructions
;Obviously there isn't really a comparable bit of Z80 syntax so I've just kinda made
;it up as I go along. 

	LD A,RES 0,(IX+offset)
	LD B,RES 0,(IX+offset)
	LD C,RES 0,(IX+offset)
	LD D,RES 0,(IX+offset)
	LD E,RES 0,(IX+offset)	
	LD H,RES 0,(IX+offset)
	LD L,RES 0,(IX+offset)

	LD A,RES 0,(IY+offset)
	LD B,RES 0,(IY+offset)
	LD C,RES 0,(IY+offset)
	LD D,RES 0,(IY+offset)
	LD E,RES 0,(IY+offset)	
	LD H,RES 0,(IY+offset)
	LD L,RES 0,(IY+offset)

	LD A,RES 1,(IX+offset)
	LD B,RES 1,(IX+offset)
	LD C,RES 1,(IX+offset)
	LD D,RES 1,(IX+offset)
	LD E,RES 1,(IX+offset)	
	LD H,RES 1,(IX+offset)
	LD L,RES 1,(IX+offset)

	LD A,RES 1,(IY+offset)
	LD B,RES 1,(IY+offset)
	LD C,RES 1,(IY+offset)
	LD D,RES 1,(IY+offset)
	LD E,RES 1,(IY+offset)
	LD H,RES 1,(IY+offset)
	LD L,RES 1,(IY+offset)

	LD A,RES 2,(IX+offset)
	LD B,RES 2,(IX+offset)
	LD C,RES 2,(IX+offset)
	LD D,RES 2,(IX+offset)
	LD E,RES 2,(IX+offset)	
	LD H,RES 2,(IX+offset)
	LD L,RES 2,(IX+offset)

	LD A,RES 2,(IY+offset)
	LD B,RES 2,(IY+offset)
	LD C,RES 2,(IY+offset)
	LD D,RES 2,(IY+offset)
	LD E,RES 2,(IY+offset)
	LD H,RES 2,(IY+offset)
	LD L,RES 2,(IY+offset)

	LD A,RES 3,(IX+offset)
	LD B,RES 3,(IX+offset)
	LD C,RES 3,(IX+offset)
	LD D,RES 3,(IX+offset)
	LD E,RES 3,(IX+offset)	
	LD H,RES 3,(IX+offset)
	LD L,RES 3,(IX+offset)

	LD A,RES 3,(IY+offset)
	LD B,RES 3,(IY+offset)
	LD C,RES 3,(IY+offset)
	LD D,RES 3,(IY+offset)
	LD E,RES 3,(IY+offset)
	LD H,RES 3,(IY+offset)
	LD L,RES 3,(IY+offset)

	LD A,RES 4,(IX+offset)
	LD B,RES 4,(IX+offset)
	LD C,RES 4,(IX+offset)
	LD D,RES 4,(IX+offset)
	LD E,RES 4,(IX+offset)	
	LD H,RES 4,(IX+offset)
	LD L,RES 4,(IX+offset)

	LD A,RES 4,(IY+offset)
	LD B,RES 4,(IY+offset)
	LD C,RES 4,(IY+offset)
	LD D,RES 4,(IY+offset)
	LD E,RES 4,(IY+offset)
	LD H,RES 4,(IY+offset)
	LD L,RES 4,(IY+offset)

	LD A,RES 5,(IX+offset)
	LD B,RES 5,(IX+offset)
	LD C,RES 5,(IX+offset)
	LD D,RES 5,(IX+offset)
	LD E,RES 5,(IX+offset)	
	LD H,RES 5,(IX+offset)
	LD L,RES 5,(IX+offset)

	LD A,RES 5,(IY+offset)
	LD B,RES 5,(IY+offset)
	LD C,RES 5,(IY+offset)
	LD D,RES 5,(IY+offset)
	LD E,RES 5,(IY+offset)
	LD H,RES 5,(IY+offset)
	LD L,RES 5,(IY+offset)

	LD A,RES 6,(IX+offset)
	LD B,RES 6,(IX+offset)
	LD C,RES 6,(IX+offset)
	LD D,RES 6,(IX+offset)
	LD E,RES 6,(IX+offset)	
	LD H,RES 6,(IX+offset)
	LD L,RES 6,(IX+offset)

	LD A,RES 6,(IY+offset)
	LD B,RES 6,(IY+offset)
	LD C,RES 6,(IY+offset)
	LD D,RES 6,(IY+offset)
	LD E,RES 6,(IY+offset)
	LD H,RES 6,(IY+offset)
	LD L,RES 6,(IY+offset)

	LD A,RES 7,(IX+offset)
	LD B,RES 7,(IX+offset)
	LD C,RES 7,(IX+offset)
	LD D,RES 7,(IX+offset)
	LD E,RES 7,(IX+offset)	
	LD H,RES 7,(IX+offset)
	LD L,RES 7,(IX+offset)

	LD A,RES 7,(IY+offset)
	LD B,RES 7,(IY+offset)
	LD C,RES 7,(IY+offset)
	LD D,RES 7,(IY+offset)
	LD E,RES 7,(IY+offset)
	LD H,RES 7,(IY+offset)
	LD L,RES 7,(IY+offset)

	LD A,RL(IX+offset)
	LD B,RL(IX+offset)
	LD C,RL(IX+offset) 
	LD D,RL(IX+offset) 
	LD E,RL(IX+offset)
	LD H,RL(IX+offset)
	LD L,RL(IX+offset)

	LD A,RL(IY+offset)
	LD B,RL(IY+offset)
	LD C,RL(IY+offset) 
	LD D,RL(IY+offset)
	LD E,RL(IY+offset)
	LD H,RL(IY+offset)
	LD L,RL(IY+offset)

	LD A,RLC(IX+offset)
	LD B,RLC(IX+offset)
	LD C,RLC(IX+offset) 
	LD D,RLC(IX+offset) 
	LD E,RLC(IX+offset)
	LD H,RLC(IX+offset)
	LD L,RLC(IX+offset)
	
	LD A,RLC(IY+offset)
	LD B,RLC(IY+offset)
	LD C,RLC(IY+offset) 
	LD D,RLC(IY+offset)
	LD E,RLC(IY+offset)
	LD H,RLC(IY+offset)
	LD L,RLC(IY+offset)

	LD A,RR(IX+offset)
	LD B,RR(IX+offset)
	LD C,RR(IX+offset) 
	LD D,RR(IX+offset) 
	LD E,RR(IX+offset)
	LD H,RR(IX+offset)
	LD L,RR(IX+offset)	

	LD A,RR(IY+offset)
	LD B,RR(IY+offset)
	LD C,RR(IY+offset) 
	LD D,RR(IY+offset)
	LD E,RR(IY+offset)
 	LD H,RR(IY+offset)
	LD L,RR(IY+offset)	

	LD A,RRC(IX+offset)
	LD B,RRC(IX+offset)
	LD C,RRC(IX+offset) 
	LD D,RRC(IX+offset) 
	LD E,RRC(IX+offset)
	LD H,RRC(IX+offset)
	LD L,RRC(IX+offset)	
	
	LD A,RRC(IY+offset)
	LD B,RRC(IY+offset)
	LD C,RRC(IY+offset) 
	LD D,RRC(IY+offset)
	LD E,RRC(IY+offset) 
	LD H,RRC(IY+offset)
	LD L,RRC(IY+offset)	

	LD A,SET 0,(IX+offset)
	LD B,SET 0,(IX+offset)
	LD C,SET 0,(IX+offset)
	LD D,SET 0,(IX+offset)
	LD E,SET 0,(IX+offset)
	LD H,SET 0,(IX+offset)
	LD L,SET 0,(IX+offset)

	LD A,SET 0,(IY+offset)
	LD B,SET 0,(IY+offset)
	LD C,SET 0,(IY+offset)
	LD D,SET 0,(IY+offset)
	LD E,SET 0,(IY+offset)
	LD H,SET 0,(IY+offset)
	LD L,SET 0,(IY+offset)

	LD A,SET 1,(IX+offset)
	LD B,SET 1,(IX+offset)
	LD C,SET 1,(IX+offset)
	LD D,SET 1,(IX+offset)
	LD E,SET 1,(IX+offset)
	LD H,SET 1,(IX+offset)
	LD L,SET 1,(IX+offset)

	LD A,SET 1,(IY+offset)
	LD B,SET 1,(IY+offset)
	LD C,SET 1,(IY+offset)
	LD D,SET 1,(IY+offset)
	LD E,SET 1,(IY+offset)
	LD H,SET 1,(IY+offset)
	LD L,SET 1,(IY+offset)

	LD A,SET 2,(IX+offset)
	LD B,SET 2,(IX+offset)
	LD C,SET 2,(IX+offset)
	LD D,SET 2,(IX+offset)
	LD E,SET 2,(IX+offset)
	LD H,SET 2,(IX+offset)
	LD L,SET 2,(IX+offset)

	LD A,SET 2,(IY+offset)
	LD B,SET 2,(IY+offset)
	LD C,SET 2,(IY+offset)
	LD D,SET 2,(IY+offset)
	LD E,SET 2,(IY+offset)
	LD H,SET 2,(IY+offset)
	LD L,SET 2,(IY+offset)

	LD A,SET 3,(IX+offset)
	LD B,SET 3,(IX+offset)
	LD C,SET 3,(IX+offset)
	LD D,SET 3,(IX+offset)
	LD E,SET 3,(IX+offset)
	LD H,SET 3,(IX+offset)
	LD L,SET 3,(IX+offset)

	LD A,SET 3,(IY+offset)
	LD B,SET 3,(IY+offset)
	LD C,SET 3,(IY+offset)
	LD D,SET 3,(IY+offset)
	LD E,SET 3,(IY+offset)
	LD H,SET 3,(IY+offset)
	LD L,SET 3,(IY+offset)

	LD A,SET 4,(IX+offset)
	LD B,SET 4,(IX+offset)
	LD C,SET 4,(IX+offset)
	LD D,SET 4,(IX+offset)
	LD E,SET 4,(IX+offset)
	LD H,SET 4,(IX+offset)
	LD L,SET 4,(IX+offset)

	LD A,SET 4,(IY+offset)
	LD B,SET 4,(IY+offset)
	LD C,SET 4,(IY+offset)
	LD D,SET 4,(IY+offset)
	LD E,SET 4,(IY+offset)
	LD H,SET 4,(IY+offset)
	LD L,SET 4,(IY+offset)

	LD A,SET 5,(IX+offset)
	LD B,SET 5,(IX+offset)
	LD C,SET 5,(IX+offset)
	LD D,SET 5,(IX+offset)
	LD E,SET 5,(IX+offset)
	LD H,SET 5,(IX+offset)
	LD L,SET 5,(IX+offset)

	LD A,SET 5,(IY+offset)
	LD B,SET 5,(IY+offset)
	LD C,SET 5,(IY+offset)
	LD D,SET 5,(IY+offset)
	LD E,SET 5,(IY+offset)
	LD H,SET 5,(IY+offset)
	LD L,SET 5,(IY+offset)

	LD A,SET 6,(IX+offset)
	LD B,SET 6,(IX+offset)
	LD C,SET 6,(IX+offset)
	LD D,SET 6,(IX+offset)
	LD E,SET 6,(IX+offset)
	LD H,SET 6,(IX+offset)
	LD L,SET 6,(IX+offset)

	LD A,SET 6,(IY+offset)
	LD B,SET 6,(IY+offset)
	LD C,SET 6,(IY+offset)
	LD D,SET 6,(IY+offset)
	LD E,SET 6,(IY+offset)
	LD H,SET 6,(IY+offset)
	LD L,SET 6,(IY+offset)

	LD A,SET 7,(IX+offset)
	LD B,SET 7,(IX+offset)
	LD C,SET 7,(IX+offset)
	LD D,SET 7,(IX+offset)
	LD E,SET 7,(IX+offset)
	LD H,SET 7,(IX+offset)
	LD L,SET 7,(IX+offset)

	LD A,SET 7,(IY+offset)
	LD B,SET 7,(IY+offset)
	LD C,SET 7,(IY+offset)
	LD D,SET 7,(IY+offset)
	LD E,SET 7,(IY+offset)
	LD H,SET 7,(IY+offset)
	LD L,SET 7,(IY+offset)

	LD A,SLA (IX+offset)
	LD B,SLA (IX+offset)
	LD C,SLA (IX+offset)
	LD D,SLA (IX+offset)
	LD E,SLA (IX+offset)
	LD H,SLA (IX+offset)
	LD L,SLA (IX+offset)

	LD A,SLA (IY+offset)
	LD B,SLA (IY+offset)
	LD C,SLA (IY+offset)
	LD D,SLA (IY+offset)
	LD E,SLA (IY+offset)
	LD H,SLA (IY+offset)
	LD L,SLA (IY+offset)

	LD A,SLL (IX+offset)
	LD B,SLL (IX+offset)
	LD C,SLL (IX+offset)
	LD D,SLL (IX+offset)
	LD E,SLL (IX+offset)
	LD H,SLL (IX+offset)
	LD L,SLL (IX+offset)

	LD A,SLL (IY+offset)
	LD B,SLL (IY+offset)
	LD C,SLL (IY+offset)
	LD D,SLL (IY+offset)
	LD E,SLL (IY+offset)
	LD H,SLL (IY+offset)
	LD L,SLL (IY+offset)

	LD A,SRA (IX+offset)
	LD B,SRA (IX+offset)
	LD C,SRA (IX+offset)
	LD D,SRA (IX+offset)
	LD E,SRA (IX+offset)
	LD H,SRA (IX+offset)
	LD L,SRA (IX+offset)

	LD A,SRA (IY+offset)
	LD B,SRA (IY+offset)
	LD C,SRA (IY+offset)
	LD D,SRA (IY+offset)
	LD E,SRA (IY+offset)
	LD H,SRA (IY+offset)
	LD L,SRA (IY+offset)

	LD A,SRL (IX+offset)
	LD B,SRL (IX+offset)
	LD C,SRL (IX+offset)
	LD D,SRL (IX+offset)
	LD E,SRL (IX+offset)
	LD H,SRL (IX+offset)
	LD L,SRL (IX+offset)

	LD A,SRL (IY+offset)
	LD B,SRL (IY+offset)
	LD C,SRL (IY+offset)
	LD D,SRL (IY+offset)
	LD E,SRL (IY+offset)
	LD H,SRL (IY+offset)
	LD L,SRL (IY+offset)

	LD A,XH
	LD A,XL
	LD A,YH
	LD A,YL
	LD B,XH
	LD B,XL
	LD B,YH
	LD B,YL
	LD C,XH
	LD C,XL
	LD C,YH
	LD C,YL
	LD D,XH
	LD D,XL
	LD D,YH
	LD D,YL
	LD E,XH
	LD E,XL
	LD E,YH
	LD E,YL

	LD XH,A
	LD XH,B
	LD XH,C
	LD XH,D
	LD XH,E
	LD XH,XH
	LD XH,XL
	LD XH,n

	LD YH,A
	LD YH,B
	LD YH,C
	LD YH,D
	LD YH,E
	LD YH,YH
	LD YH,YL
	LD YH,n

	LD XL,A
	LD XL,B
	LD XL,C
	LD XL,D
	LD XL,E
	LD XL,XH
	LD XL,XL
	LD XL,n

	LD YL,A
	LD YL,B
	LD YL,C
	LD YL,D
	LD YL,E
	LD YL,YH
	LD YH,YL
	LD YL,n

	OR XH
	OR XL
	OR YH
	OR YL
	
	OUT0 (C); Do an OUT (C),0 but presuambly faster or something.

	RST	1
	RST	2
	RST	3
	RST	4
	RST	5
	RST	6
	RST	7	

	SBC A,XH
	SBC A,XL
	SBC A,YH
	SBC A,YL
	
	SLL B
	SLL C
	SLL D
	SLL E
	SLL H
	SLL L
	SLL (HL)
	SLL (IX+offset)
	SLL (IY+offset)
	SLL A	

	SUB XH
	SUB XL
	SUB YH
	SUB YL
	
	XOR XH
	XOR XL
	XOR YH
	XOR YL

	
#include "testz80.asm"
